unit Unit6;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ScrMemo, IDEMain, Vcl.StdCtrls, atScript, atScripter;

type
  TRandomObj = class
  protected
  private
    Frandomid: int64;
    Ftext: string;
  published
    property randomid: int64 read Frandomid write Frandomid;
    property text: string read Ftext write Ftext;
  end;

  TForm6 = class(TForm)
    atScripter1: TatScripter;
    Button1: TButton;
    IDEMemo1: TIDEMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    RandomObj: TRandomObj;
  public
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
  RandomObj.text := 'testobj';
  atScripter1.SourceCode := IDEMemo1.Lines;
  atScripter1.ExecuteSubRoutine('PassRandomObj', 2);
end;

procedure TForm6.Button2Click(Sender: TObject);
begin
  ShowMessage(RandomObj.text);
end;

procedure TForm6.FormCreate(Sender: TObject);
begin
  RandomObj := TRandomObj.Create;
  atScripter1.DefineClassByRTTI(TRandomObj);
  atScripter1.AddObject('rdmobj', RandomObj);
end;

end.
